{+--------------------------------------------------------------------------+
 | Copyright (c) 1998 Martin Waldenburg
 | No rights reserved.
 | DISCLAIMER:  This is provided as is, expressly without a warranty of any kind.
 |              You use it at your own risc.
 +--------------------------------------------------------------------------+}
unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Del1Edit, Spin;

type
  TForm1 = class(TForm)
    Up: TButton;
    Down: TButton;
    PageUp: TButton;
    PageDown: TButton;
    GotoLine: TButton;
    SpinEdit1: TSpinEdit;
    EditHandles: TmwDel1EditHandles;
    CopyAtCaret: TButton;
    Edit1: TEdit;
    Top: TButton;
    Bottom: TButton;
    SetCaret: TButton;
    InsertAtLine: TButton;
    LineCount: TButton;
    Memo1: TMemo;
    LineAtTop: TButton;
    GetAllLines: TButton;
    Edit2: TEdit;
    LineAtCaret: TButton;
    ReplaceAtCaret: TButton;
    procedure UpClick(Sender: TObject);
    procedure DownClick(Sender: TObject);
    procedure PageUpClick(Sender: TObject);
    procedure PageDownClick(Sender: TObject);
    procedure GotoLineClick(Sender: TObject);
    procedure CopyAtCaretClick(Sender: TObject);
    procedure TopClick(Sender: TObject);
    procedure BottomClick(Sender: TObject);
    procedure SetCaretClick(Sender: TObject);
    procedure InsertAtLineClick(Sender: TObject);
    procedure LineCountClick(Sender: TObject);
    procedure LineAtTopClick(Sender: TObject);
    procedure GetAllLinesClick(Sender: TObject);
    procedure LineAtCaretClick(Sender: TObject);
    procedure ReplaceAtCaretClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.UpClick(Sender: TObject);
begin
  EditHandles.LineUp;
end;

procedure TForm1.DownClick(Sender: TObject);
var
  aPos: Integer;
begin
  EditHandles.LineDown;
  aPos:= GetScrollPos(EditHandles.VSCROLL, SB_CTL);
  Edit1.Text:= IntToStr(aPos);
end;

procedure TForm1.PageUpClick(Sender: TObject);
begin
  EditHandles.PageUp;
end;

procedure TForm1.PageDownClick(Sender: TObject);
begin
  EditHandles.PageDown;
end;

procedure TForm1.TopClick(Sender: TObject);
begin
  EditHandles.ScrollTop;
end;

procedure TForm1.BottomClick(Sender: TObject);
begin
  EditHandles.ScrollBottom;
end;


procedure TForm1.GotoLineClick(Sender: TObject);
begin
  EditHandles.Top:= SpinEdit1.Value;
end;

procedure TForm1.CopyAtCaretClick(Sender: TObject);
begin
  Edit1.Text:= EditHandles.WordAtCaret;
end;

procedure TForm1.SetCaretClick(Sender: TObject);
var
  aPos: LongInt;
  xPos, yPos: Integer;
begin
  {Die Position wird ber den zweiten Parameter angegeben und
   zuvor mit MakeLong erzeugt werden.
   Die Zeichenposition mu anhand des Fonts berechnet werden
   Die X und Y Werte mssen sich im sichtbaren Bereich des Fensters
   befinden, sonst wird das Caret nicht bewegt.}

  aPos:= MakeLong(50, 200);

  SendMessage(EditHandles.EditControl, WM_LBUTTONDOWN, 0, aPos);
  SendMessage(EditHandles.EditControl, WM_LBUTTONUP, 0, aPos);
end;

procedure TForm1.InsertAtLineClick(Sender: TObject);
begin
  EditHandles.InsertLine(SpinEdit1.Value, Edit1.Text);
end;

procedure TForm1.LineCountClick(Sender: TObject);
begin
  Edit1.Text:= IntToStr(EditHandles.LineCount);
end;

procedure TForm1.LineAtTopClick(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.Lines.Add(EditHandles.TopLine);
end;

procedure TForm1.GetAllLinesClick(Sender: TObject);
var
  I, LCount: Integer;
begin
  Memo1.Clear;
  EditHandles.Top:= 1;
  LCount:= EditHandles.LineCount;
  for I:= 1 to LCount do Memo1.Lines.Add(EditHandles.Lines[I]);
end;

procedure TForm1.LineAtCaretClick(Sender: TObject);
begin
  Edit1.Text:= EditHandles.CaretLine;
end;

procedure TForm1.ReplaceAtCaretClick(Sender: TObject);
begin
  EditHandles.CaretLine:= Edit1.Text;
end;

end.


